# include <stdio.h>
# include <stdlib.h>
# include <string.h>

# include "struct.h"

extern char * str_buf_head;
extern char * str_buf_end;

extern FILE * yyin;

char cmdline_buffer[127];

Record rules[Rsize];

int rules_num = 0;
int lextime;

FILE * source = stdin;
FILE * output = stdout;

void catarg(int argc, char * argv[], char * buffer) 
{
  int i;
  char * str;
  str = buffer;
  for (i=1; i<argc; i++){
    strcpy(str,argv[i]);
    str += strlen(argv[i]);
    if (i==(argc-1)) *str='\0';
      else *str=' '; 
    str ++;
    }
}

cmdwrap()
{
  return(1);
}

/******************************************************************/

int recordcmp(Record * rec1, Record * rec2)
{
  return(strcmp(rec1->name, rec2->name));
}


main (int argc, char * argv[])
{

  catarg(argc, argv, cmdline_buffer);

  str_buf_head=cmdline_buffer;
  str_buf_end=str_buf_head + strlen(cmdline_buffer) + 1;

  cmdlex();

  yyin=fopen("rules.list", "r");

  lextime=0;  
  yylex();

  qsort(rules, rules_num+1, sizeof(Record), (void * )recordcmp);

  {
    int i;
    for(i=1; i<rules_num; i++){
      if (strcmp(rules[i].name, rules[i+1].name)==0)
	printf("%s\n", rules[i].name);
    };
  };

  yyin = source;

  yylex();


  { 
    int i,j, sum=0;
    int untouched=0;

    for(i=1;i<=rules_num;i++){
      sum=sum+rules[i].number;
      printf("% 4d. %s\t: ", i, rules[i].name);
      for(j=1;j<=rules[i].number;j++){
	printf("(O%02d) %d   ", j, rules[i].option[j]);
	if(rules[i].option[j]==0)
	  untouched++;
      };
      printf("\n");
    }

    printf("\n\nThere are total %d options. %d touched\n", sum, (sum-untouched));
  }

/*
  yyin = source;

  yylex();
*/

}










